#!/usr/bin/env python
# Software License Agreement (BSD License)
#
# Copyright (c) 2008, Willow Garage, Inc.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#  * Neither the name of Willow Garage, Inc. nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# Revision $Id: talker.py 3803 2009-02-11 02:04:39Z rob_wheeler $

import roslib; roslib.load_manifest('pr2_alpha')

import rospy
import sys
from std_msgs.msg import String

class SubPub():

  def __init__(self):
    argv = rospy.myargv()
    self.name = argv[1]
    self.expected_names = argv[1:]
    self.received = False
    self.pub = rospy.Publisher('subpub', String)
    self.pub_success = rospy.Publisher('success', String)
    rospy.Subscriber('subpub', String, self.callback)
    rospy.init_node('subpub', anonymous=True)

  def callback(self, name):
    for i in range(0,len(self.expected_names)):
      if name.data == self.expected_names[i]:
        del self.expected_names[i]
        break
    if len(self.expected_names) == 0:
      self.received = True

  def go(self):
    while not rospy.is_shutdown():
      str = self.name
      self.pub.publish(String(str))
      if self.received:
        self.pub_success.publish(String(str))
      rospy.sleep(0.01)

if __name__ == '__main__':
  sp = SubPub()
  sp.go()
